"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
const inversify_1 = require("inversify");
const constant_parameter_builder_1 = require("./../parameter/constant-parameter-builder");
const not_specified_param_exception_1 = require("./../../../exception/not-specified-param-exception");
const inversify_2 = require("inversify");
const types_1 = require("../../../container/types");
const index_1 = require("../../../index");
const HANDLE_REQUEST = "handleRequest";
let MultiserverMiddlewareBuilder = MultiserverMiddlewareBuilder_1 = class MultiserverMiddlewareBuilder {
    constructor(container, tsHubLogger) {
        this.container = container;
        this.tsHubLogger = tsHubLogger;
        this.middlewareSupport = [];
        if (!tsHubLogger) {
            throw new not_specified_param_exception_1.NotSpecifiedParamException("propertyKey", MultiserverMiddlewareBuilder_1.name);
        }
    }
    withMiddlewareConstructor(middlewareConstructor) {
        if (!middlewareConstructor) {
            throw new not_specified_param_exception_1.NotSpecifiedParamException("middlewareConstructor", index_1.ConstructorMiddlewareBuilder.name);
        }
        this.middlewareConstructor = middlewareConstructor;
        return this;
    }
    addMiddlewareSupport(middlewareSupport) {
        if (!middlewareSupport || !middlewareSupport.activator || !middlewareSupport.support) {
            throw new not_specified_param_exception_1.NotSpecifiedParamException("middlewareSupport", this.addMiddlewareSupport.name);
        }
        this.middlewareSupport.push(middlewareSupport);
        return this;
    }
    withMiddlewareSupport(middlewareSupport = []) {
        this.middlewareSupport = [];
        middlewareSupport.forEach(x => this.addMiddlewareSupport(x));
        return this;
    }
    withInformation(information) {
        this.information = information;
        return this;
    }
    withTarget(target) {
        this.target = target;
        return this;
    }
    withPropertyKey(propertyKey) {
        this.propertyKey = propertyKey;
        return this;
    }
    withPriority(priority) {
        this.priority = priority;
        return this;
    }
    buildMiddleware(router) {
        if (!router) {
            throw new not_specified_param_exception_1.NotSpecifiedParamException("router", this.buildMiddleware.name);
        }
        var middlewareSupport = this.middlewareSupport.find(x => x.support.supportsServer(router));
        if (middlewareSupport) {
            this.tsHubLogger.debug(`Middleware "${this.middlewareConstructor.prototype.name}" being build.`);
            let activator = this.container.bindAndGet(middlewareSupport.activator);
            let middleware = activator.buildControllerActivationMiddleware(this.middlewareConstructor.prototype, HANDLE_REQUEST, router, [new constant_parameter_builder_1.ConstantParameterBuilder(this.information, 0)]);
            middleware.priority = this.priority;
            return middleware;
        }
    }
    supportsRouter(router) {
        return this.middlewareSupport.some(x => x.support.supportsServer(router));
    }
};
MultiserverMiddlewareBuilder = MultiserverMiddlewareBuilder_1 = __decorate([
    inversify_2.injectable(),
    __param(0, inversify_1.inject(types_1.Types.Container)),
    __param(1, inversify_1.inject(types_1.Types.TsHubLogger)),
    __metadata("design:paramtypes", [Object, Object])
], MultiserverMiddlewareBuilder);
exports.MultiserverMiddlewareBuilder = MultiserverMiddlewareBuilder;
var MultiserverMiddlewareBuilder_1;
//# sourceMappingURL=multiserver-middleware-builder.js.map