import { HubContainer } from './../../../container/hub-container';
import { MiddlewareSupport } from './middleware-support';
import { Middleware } from './../../middleware';
import { TsHubLogger } from './../../../logging/ts-hub-logger';
import { Handler } from './handler';
import { MiddlewareBuilder } from './middleware-builder';
export declare class MultiserverMiddlewareBuilder<Information> implements MiddlewareBuilder<Information, any, any> {
    protected container: HubContainer;
    protected tsHubLogger: TsHubLogger;
    protected information: Information;
    protected target: any;
    protected propertyKey: string;
    protected middlewareConstructor: new (...args: any[]) => Handler<Information>;
    protected middlewareSupport: MiddlewareSupport<Information>[];
    protected priority: number;
    constructor(container: HubContainer, tsHubLogger: TsHubLogger);
    withMiddlewareConstructor(middlewareConstructor: new (...args: any[]) => Handler<Information>): this;
    addMiddlewareSupport(middlewareSupport: MiddlewareSupport<Information>): this;
    withMiddlewareSupport(middlewareSupport?: MiddlewareSupport<Information>[]): this;
    withInformation(information: Information): this;
    withTarget(target: any): this;
    withPropertyKey(propertyKey: string): this;
    withPriority(priority: number): this;
    buildMiddleware(router: any): Middleware<Information, any>;
    supportsRouter(router: any): boolean;
}
