import { Middleware } from "../../middleware";
import { Route } from "../../route";
import { ControllerActivator } from "../../activator/controller-activator";
import { MiddlewareReader } from "../../reader";
import { RouteBuilder } from "./route-builder";
import "reflect-metadata";
export declare abstract class DefaultRouteBuilder<Information, GenericRouter, RequestHandler> implements RouteBuilder<Information, GenericRouter, RequestHandler> {
    protected middlewareReader: MiddlewareReader;
    protected activator: ControllerActivator<GenericRouter, RequestHandler>;
    protected information: Information;
    protected target: any;
    protected propertyKey: string;
    constructor(middlewareReader: MiddlewareReader, activator: ControllerActivator<GenericRouter, RequestHandler>);
    abstract supportsRouter(router: GenericRouter): boolean;
    buildRoute(router: GenericRouter): Route<Information, GenericRouter, RequestHandler>;
    protected abstract createRouteInstance(): Route<Information, GenericRouter, RequestHandler>;
    protected buildRouteMiddleware(router: GenericRouter): Middleware<any, RequestHandler>[];
    withInformation(information: Information): this;
    withTarget(target: any): this;
    withPropertyKey(propertyKey: string): this;
}
